<?
/******************************************************************************
Funktionen fr Kreditkarten-Verification

Sprache		: PHP3
Copyright	: http://www.caupo.de/shop/licence.txt
Author(en) 	: Andreas Kempf
Datum		: 1999-07-16
Version		: 1.0
Datei		: functions_ccv.inc.php3

Testing numbers:
American Express: 3111 1111 1111 117 
Visa			: 4111 1111 1111 1111 
MasterCard		: 5111 1111 1111 1118 
Discover		: 6111 1111 1111 1116 

MASTERCARD numbers are 16 digits long 
VISA numbers are 13 or 16 digits long 
AMEX number are 15 digits long 


*******************************************************************************/

/******************************************************************************
returnwert			function				argumente
-------------------------------------------------------------------------------
1/0					FncCC 					$svKreditk_Typ,$nCCn

******************************************************************************/

// Setze Variable fr diese Funktionsbibliothek
$bFncFile["ccv"] = true;

/******************************************************************************
 Function 	: FncCC  
 Arguments  : ($svKreditk_Typ,$nCCn)
 Description: Checks Creditcard Number
 Returns  	: 1/0
 Echos		: -
 Templates 	: -
 Date		: 1999-07-16
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/
 
function FncCC ($svKreditk_Typ,$nCCn)
{
	/*Remove spaces and dashes in the Card Number*/
	$nCCn 	= ereg_replace(" ","",$nCCn);
	$nCCn 	= ereg_replace("-","",$nCCn);  
	$length = strlen($nCCn);

	// Je nach karte payment definieren
	switch ($svKreditk_Typ)
	{
		case "Visa":
			if ($length == 13 or $length == 16)
				$bCheck = 1;
		break;

		case "Master Card":
			if ($length == 16)
				$bCheck = 1;
		break;

		case "American Express":
			if ($length == 15)
				$bCheck = 1;
		break;

		case "Discover":
			if ($length == 15)
				$bCheck = 1;
		break;
	};

	// Check for illegal characters in the Card Number
	if(ereg_replace( "[^0-9]", "",$nCCn)==0)
	{	
		$bCardOk = 0;
	}
	elseif ($bCheck)
	{
		// Create array of cardnumbers
		for ($x=0;$x<$length;$x++)
		{	$naCC[$x] = substr($nCCn,$x,1);
			SetType($naCC[$x],"integer");
		}

		for ($x=0;$x<=$length-2;$x=$x+2)
		{	$naCCa[$x] = $naCC[$x] * 2;
			
			if($naCCa[$x] >= 10)
			{	$naCCb[$x] = substr($naCCa[$x],0,1);
				$naCCc[$x] = substr($naCCa[$x],1,1);
				$naCC[$x] = $naCCb[$x]+$naCCc[$x];
			}
			else
			{	$naCC[$x] = $naCCa[$x];
			}
		}
	
		// Checksum
		for ($x=0;$x<$length;$x++)
		{	$val += $naCC[$x];
		}

		if(substr($val,1,1) == "0")
			$bCardOk = 1;
		else
			$bCardOk = 0;
	}
	else
	{       
		$bCardOk = 0;
	}

return $bCardOk;
};

?>