<?
/******************************************************************************

Allgemeine Funktionen fr den Caupo Shop

Sprache		: PHP3
Copyright	: http://www.caupo.de/shop/licence.txt
Author(en) 	: Andreas Kempf
Datum		: 1999-07-20
Version		: 1.0
Datei		: functions_general.inc.php3

*******************************************************************************/

/******************************************************************************
returnwert			function				argumente
-------------------------------------------------------------------------------
$nID				FncMakeVisitID
$svDateOutput		FncChangeTimestamp 		$svDate, $svDateOutput
$dbconnectid		FncOpenDatabase
1/0 				FncOnlyDigits 			$svValue
1/0					FncNoDigits 			$svValue
1/0					FncCheckEmail 			$svEmail
					FncSelectBoxSelected 	$svSQLVar, $svHtmlVar
$svImageComplete	FncImgTag 				$svThumbnail, $svVollBild, $svArtikel

******************************************************************************/

// Setze Variable fr diese Funktionsbibliothek
$bFncFile["general"] = true;


/******************************************************************************
 Function 	: FncMakeVisitID
 Arguments  : -
 Description: Erstellt Visit-ID, die fr den Warenkorb notwendig ist und mache einen timestamp
 Returns  	: svRandom/0
 Echos		: -
 Templates 	: -
 Date		: 1999-07-26
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncMakeVisitID ()
{
	include ("inc/var_sql.inc.php3");

	$connectionID = FncOpenDatabase ();

	// Random-string
	srand((double)microtime()*1000000);			// setze seed
	$svZeichen = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890"; 	// mgliche zeichen
	$svRandom = "";				// Init
	while (strlen($svRandom) < 16) 	// Bilde Random-string
	{	$svRandom .= substr($svZeichen,(rand()%(strlen($svZeichen))),1); // Whle beliebiges zeichen aus und setze es zu random-string zusammen
	}

	// Insert
	$svSQL = "insert into $cfgTabVisit (visit_key) values ('$svRandom')";
	if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";		
	$result = mysql_query( $svSQL,$connectionID);
	
	if ($result)
	{	return $svRandom;
	}
	else
	{	return "0";
	}
};

/******************************************************************************
 Function 	: FncChangeTimestamp
 Arguments  : $svDate, $svDateOutput
 Description: Umformatieren Timestamp
 Returns  	: $svDateOutput
 Echos		: -
 Templates 	: -
 Date		: 1999-07-26
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
 
svDateOutput z.b. YYYY-MM-DD hh:mm:ss
   year = YYYY
   month = MM
   day = DD
   hour = hh
   minute = mm
   Second = ss
*******************************************************************************/

function FncChangeTimestamp ($svDate, $svDateOutput)
{
	// Ziehe das datum raus
	$year  = substr($svDate,0,4);
	$month = substr($svDate,4,2);
	$day   = substr($svDate,6,2);
	$hour  = substr($svDate,8,2);
	$minute= substr($svDate,10,2);
	$sec   = substr($svDate,12,2);

	$svDateOutput = ereg_replace ("YYYY", $year, $svDateOutput);
	$svDateOutput = ereg_replace ("MM", $month, $svDateOutput);
	$svDateOutput = ereg_replace ("DD", $day, $svDateOutput);
	$svDateOutput = ereg_replace ("hh", $hour, $svDateOutput);
	$svDateOutput = ereg_replace ("mm", $minute, $svDateOutput);
	$svDateOutput = ereg_replace ("ss", $sec, $svDateOutput);
	    
	return $svDateOutput;
};

/******************************************************************************
 Function 	: FncOpenDatabase
 Arguments  : -
 Description: ffnet Datenbank-Connection
 Returns  	: $nConnID
 Echos		: -
 Templates 	: -
 Date		: 1999-07-26
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncOpenDatabase ()
{
	include ("inc/var_sql.inc.php3");

	$nConnID = MySQL_pconnect( $cfgSQLDataSource, $cfgSQLUsername, $cfgSQLPasswd);
	$bCheck = mysql_select_db($cfgSQLDataBase, $nConnID);

	// berprfe, ob Connection stattgefunden hat
	if($nConnID == 0)
	{	echo "Connection to SQL-Server failed";
		exit;
	}

	if($bCheck == 0)
	{	echo "Connection to database failed";
		exit;
	}

	return $nConnID;
};

/******************************************************************************
 Function 	: FncOnlyDigits
 Arguments  : $svValue
 Description: Prft Input-Felder auf Zahlen
 Returns  	: 1/0
 Echos		: -
 Templates 	: -
 Date		: 1999-04-21
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncOnlyDigits ($svValue) 
{ 
	$svCheckValue = ereg_replace( "[^0-9]", "",$svValue);
  	if ($svCheckValue == $svValue)
	{	return "1";
  	}
  	else
  	{	return "0";
  	}
};

/******************************************************************************
 Function 	: FncNoDigits
 Arguments  : $svValue
 Description: Prft Input-Felder, ob sie nur buchstaben beinhalten
 Returns  	: 1/0
 Echos		: -
 Templates 	: -
 Date		: 1999-04-21
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function  FncNoDigits ($svValue) 
{ 
	if (ereg_replace( "[0-9]", "",$svValue)==$svValue)
	{	return "1";
  	}
  	else
  	{	return "0";
  	}
};

/******************************************************************************
 Function 	: FncCheckEmail
 Arguments  : $svEmail
 Description: Prft Email-Adresse auf @ und "." und gibt 1 zurck, wenn enthalten
 Returns  	: 1/0
 Echos		: -
 Templates 	: -
 Date		: 1999-04-21
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function  FncCheckEmail ($svEmail) 
{
	$bCheck = 1;
	if  (ereg_replace( "@", "",$svEmail)==$svEmail)
	{	$bCheck = 0;
  	}
	if  (ereg_replace( ".", "",$svEmail)==$svEmail)
	{	$bCheck = 0;
  	}
  	
	return $bCheck;
  	
};

/******************************************************************************
 Function 	: FncSelectBoxSelected
 Arguments  : $svSQLVar, $svHtmlVar
 Description: berprft zwei Eintrge, wenn identisch, wird "selected" ausgegeben
 Returns  	: -
 Echos		: "selected"
 Templates 	: -
 Date		: 1999-04-21
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncSelectBoxSelected ($svSQLVar, $svHtmlVar)
{
	if ($svSQLVar == $svHtmlVar)
	{	echo "selected";
	}
};

/******************************************************************************
 Function 	: FncStoreFile
 Arguments  : $svFile, $svFile_name
 Description: Datei-Upload
 Returns  	: $svFile_name
 Echos		: -
 Templates 	: -
 Date		: 1999-08-10
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncStoreFile ($svFile, $svFile_name)
{
	include ("inc/var_general.inc.php3");

	if (strlen ($svFile_name) != 0 && $svFile != "none")
	{	$svSourcePath = $svFile;
		$svTargetPath = $cfgShopImagePath . $svFile_name;

		copy ($svSourcePath,$svTargetPath);
		chmod ($svTargetPath, "0777");

	}
	else
	{	$svFile_name = "";
	}

return($svFile_name);
};

/******************************************************************************
 Function 	: FncImgTag
 Arguments  : $svThumbnail, $svVollBild, $svArtikel
 Description: Mache komplettes Image-Tag und gebe es als retrun zurck
 Returns  	: $svImageComplete
 Echos		: -
 Templates 	: -
 Date		: 1999-07-26
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncImgTag ($svThumbnail, $svVollBild, $svArtikel)
{
	error_reporting(0);
	if (DEBUG) echo "\n<!-- debug: $svThumbnail,$svVollBild -->\n";
	// Wenn thumbnail vorhanden
	if (strlen($svThumbnail) != 0)
	{	$saImSize = GetImageSize("images/$svThumbnail");
		$svImageSmall = "<img src=\"images/$svThumbnail\" width=\"$saImSize[0]\" height=\"$saImSize[1]\" alt=\"$svArtikel\" border=\"0\">";

		// Wenn Vollbild vorhanden
		if (strlen($svVollBild) > 1)
		{	$svImageBig = "images/" . $svVollBild;
			$svImageComplete = "<a href=\"vollbild.php3?svImageBig=" . $svImageBig . "\">" . $svImageSmall . "</a>";
		}
		else
		{	$svImageComplete = $svImageSmall;
		}
	}
	else
	{	$svImageComplete = "";
	}
		

	return $svImageComplete;
};		

?>